#include <iostream>
#include <map>
#include <fstream>
#include <list>
#include <queue>
#include <vector>
#include<conio.h>
#include <sys/timeb.h>
#include <ctime>
#define min(a, b) ((a) < (b) ? (a) : (b))  
using namespace std;
struct positionCode
{
        unsigned int code;
	    positionCode *next;		
};

struct node
{	
  	int event;
  	int occur;
  	int pcLength;
	positionCode *pcCode;
	int CountSon;	
  	node *nextLink;	
  	node *lSon;	
  	node *rSibling;
  	node *parent;
};

struct linkheader 
{			
        int event;
        int occur;
        node *link;
        node *lastLink;	
};
//***************************************************************

typedef multimap<int, int, less<int> > sequence; 
list<linkheader> lnkhdr; 	
node *root;		
int frequency;	
int seqNumber;	
float minSupp;	
int npartition=0;
int z=1;	
int transtart=0,tranend=0;
void BuildTree();
positionCode* makeCode(int, positionCode*, bool);
int checkPosition(positionCode*, int, positionCode*, int);
void MiningProcess(list<node*>, queue<int>, int );	
/*Code from line number 54 -57 is written by Vishnu Priya R et al.,*/
ifstream intree ("sequentialdatabase .txt", ios::in);//transaction data
ifstream hdrcount("sequentialdatabase .txt", ios::in);//transaction data
ifstream items("seq(item).txt", ios::in);//items with total tran 
ifstream notran("seq(txn).txt",ios::in);//partition details

//*********************************************************
int main()
{
    cout << "please enter the minimum support:";  		
	cin >> minSupp;
	cout<<"\n";
    cout<<"enter the number of partition:";
    cin>>npartition;
    //*************************************
    /*Code from line number 69 -116 is written by Vishnu Priya R et al.,*/
   	linkheader *newLinkHeader;
        int item,total;
        items>>total;
        for(int y=0;y<total;y++)
        {
               items>>item;
                newLinkHeader = new linkheader;
                newLinkHeader->link = NULL;
                newLinkHeader->lastLink = NULL;
                newLinkHeader->event= item;
                newLinkHeader->occur= 0;
                lnkhdr.push_back(*newLinkHeader);
                free(newLinkHeader);
        }
//*****************************
        root = new node;
        root->event = -1;
        root->occur = tranend;
        root->CountSon = 0;
        root->pcLength = 0;
        root->parent = NULL;
        root->lSon = NULL;
        root->rSibling = NULL;
        root->nextLink = NULL;
        root->pcLength = 0;
//*********************
clock_t start, end;
double cpu_time_used;
	for(int i=0;i<npartition;i++)
	{   
    notran>>tranend;
    if(z==npartition)
    {
    start = clock();  
    }
    BuildTree(); 
    list<node*> newRootSet;
    queue<int> beginPattern;
  	newRootSet.push_back(root);
	cout<<"\n\nBegin the mining process"<<endl;
	if(z==npartition)
	{
    MiningProcess(newRootSet, beginPattern, tranend);
    end = clock();
    cpu_time_used = ((double) (end - start)) / CLOCKS_PER_SEC;
	}	
	z++;	      
    }
    
	cout<<"The CPU time used is : "<< cpu_time_used << endl;
	getch();
    return 0;	
}

void MiningProcess(list<node*> rootSet, queue<int> basePattern, int Count)
{	
		list<linkheader>::iterator pnt;
        for( pnt = lnkhdr.begin(); pnt != lnkhdr.end(); pnt++)
        {
             if(pnt->occur>=frequency)
             {
                list<node*> newRootSet;
                node * SavePoint = NULL;
                bool DescSave = false;
                bool RootUsed = false;
                int totalSon = 0;
                int count = 0;
                int emptySon = 0;
                int RootCount = Count;
                node * linkBrow = pnt -> link;
                list<node*>::iterator rootBrow = rootSet.begin();

                while (linkBrow != NULL && rootBrow != rootSet.end() && RootCount >= frequency &&pnt->occur>=frequency)///*Modified by Vishnu Priya R*/
                {
                        int check = checkPosition(((*rootBrow)->lSon)->pcCode, ((*rootBrow)->lSon)->pcLength, linkBrow->pcCode, linkBrow->pcLength);
					     	switch ( check ){
                            
                        case 0:
                                if ( SavePoint != NULL )
                                {
                                        if ( SavePoint->lSon == NULL )
                                                DescSave = false;
                                        else{
                                              if (checkPosition((SavePoint->lSon)->pcCode, (SavePoint->lSon)->pcLength, linkBrow->pcCode, linkBrow->pcLength)== 0)
                                                 DescSave = true;
                                                else DescSave = false;}
                                }

                                if ( !DescSave)
                                {
                                        count = count + linkBrow->occur;
                                        totalSon = totalSon + linkBrow->CountSon;
                                        RootUsed = true;
                                        SavePoint = linkBrow;
                                        if (linkBrow->lSon != NULL)
                                                newRootSet.push_back(linkBrow);
                                        else
                                                emptySon = emptySon + linkBrow->occur;
                                }
                                linkBrow = linkBrow->nextLink;
                                break;
                        case 1:
                                
                                rootBrow++;
                                RootUsed = false;
                                break;
                        case 2:
                                
                                linkBrow = linkBrow->nextLink;
                                break;
                        case 3:
                               
                                linkBrow = linkBrow->nextLink;
                                break;
                                
                        }//switch
                }//while

                if ( count >= frequency)
                {
                       queue<int> tempPattern = basePattern;
                       tempPattern.push(pnt->event);
                       queue<int> otherPattern = tempPattern;
                       
                        while(!tempPattern.empty())
                        {
                         tempPattern.pop();
                        }
                        if ( totalSon >= frequency)
                              {                              
                                MiningProcess(newRootSet, otherPattern, count-emptySon);}
                }
        }
        
    } 
        return;
}



void BuildTree()
{
     /*Code from line number 221-237 is written by Vishnu Priya R et al.,*/
     int event, cid, number;
      frequency = (int)(minSupp*tranend);
       cout<<"min:"<<minSupp<<"  "<<"total tran:"<<tranend<<"   "<<"Support:"<<frequency<<"\n";
//*********************************************************
      sequence duplicate;
      sequence::iterator i;
        
  for(int s=transtart;s<tranend;s++)
	{
        
          hdrcount>> number;
          duplicate.clear();
		for(int i=0; i< number; i++)
        {
			hdrcount>> event;
			if ( duplicate.find(event) == duplicate.end())
            {
        		duplicate.insert(sequence::value_type(event, 1));
        		 for(list<linkheader>::iterator it = lnkhdr.begin(); it != lnkhdr.end();it++)
                     if(it->event==event)
                       {it->occur+=1;
                        break;
                       }
            }
          }  
      } 
      
      
    //*****************************************************  
       node *Tranversal, *newNode, *Parent;
       for(int u=transtart;u<tranend;u++)
		{
			
			intree >> number;///*Added by Vishnu Priya R et al.,*/
			Tranversal = root;

			for(int i=0; i< number; i++)
			{
				intree >> event;
			      Parent = Tranversal;
                        if( Tranversal->lSon == NULL)						
                        {
                                newNode = new node;
                                newNode->event = event;
                                newNode->occur = 1;
                                newNode->lSon = NULL;
                                newNode->rSibling = NULL;
								newNode->nextLink = NULL;
                                newNode->CountSon = 0;
                                Parent->CountSon ++;
                                newNode->parent = Parent;
                                newNode->pcLength = Tranversal->pcLength + 1;
                                newNode->pcCode = makeCode(Tranversal->pcLength,Tranversal->pcCode,true);
                                Tranversal->lSon = newNode;
                                Tranversal = newNode;
                        }
                        else
                        {						
                                Tranversal = Tranversal->lSon;
                                if ( Tranversal->event == event)								
                                {
                                        (Tranversal->parent)->CountSon++;
                                        Tranversal->occur++;
                                }
                                else
                                {
                                        bool find= false;
                                        while(Tranversal->rSibling != NULL && !find )									
                                        {
                                                Tranversal = Tranversal->rSibling;
                                                if ( Tranversal->event == event)
                                                {
                                                        Tranversal->occur ++;
                                                        (Tranversal->parent)->CountSon++;
                                                        find = true;
                                                }
                                        }
                                        if (!find)									
                                        {
                                                newNode = new node;
                                                newNode->event = event;
                                                newNode->occur = 1;
                                                newNode->lSon = NULL;
                                                newNode->rSibling = NULL;
												newNode->nextLink = NULL;
												newNode->CountSon = 0;
                                                Parent->CountSon ++;
                                                newNode->parent = Parent;
                                                newNode->pcLength = Tranversal->pcLength + 1;
                                                newNode->pcCode = makeCode(Tranversal->pcLength,Tranversal->pcCode, false);
                                                Tranversal->rSibling = newNode;
                                                Tranversal = newNode;
                                        }
                                }
                        }
				}
		}
		transtart=tranend;//added by us
		
//***************************************************
        
}

positionCode * makeCode(int length, positionCode *pCode, bool addOne)
{
		positionCode *start, *browser, *newPC;
        int leftCount = length % 32;
        int linkCount = (int)(length / 32);

        if ( linkCount == 0 )
        {
                start = new positionCode;
                start->next = NULL;
                if (length == 0)
                        start->code = 1 << 31;
                else
                        if (addOne)
                                start->code = pCode->code | (1<<(31-leftCount));
                        else
                                start->code = pCode->code ;
                return start;
        }
        else
        {
                newPC = new positionCode;
                newPC->code = pCode->code;
                pCode = pCode ->next;
                start = newPC;
                browser = start;

                for(int i = 1; i < linkCount; i++)
                {
                        newPC = new positionCode;
                        newPC->code = pCode->code;
                        browser-> next = newPC;
                        browser = newPC;
                        pCode = pCode->next;
                }

                if (leftCount == 0)
                {
                        newPC = new positionCode;
                        if (addOne)
                                newPC->code = 1 << 31;
                        else
                                newPC->code = 0 << 31;
                        newPC->next = NULL;
                        browser->next = newPC;
                }
                else
                {
                        newPC = new positionCode;

                        if (addOne)
                                newPC->code = pCode->code | (1<<(31-leftCount));
                        else
                                newPC->code = pCode->code;

                        newPC ->next = NULL;
                        browser->next = newPC;
                }
        }

        return start;
}


int checkPosition(positionCode *FirstNode, int aLength, positionCode *SecondNode, int dLength)
{

        if (aLength == 1 )	
                return 0;	
			  int length = min(aLength,dLength);  
			  int linkCount = (int)(length / 32);
        int leftCount = length % 32;

        for( int i = 0; i < linkCount; i++)
                if ( FirstNode->code > SecondNode->code)
                        return 1;
                else
                        if ( FirstNode->code < SecondNode->code)
                                return 2;
                        else
                        {
                                FirstNode = FirstNode->next;
                                SecondNode = SecondNode->next;
                        };


        unsigned int aCode, dCode;
        if ( aLength <= dLength )
        {
                if (leftCount == 0)
                        return 0;

                aCode = FirstNode -> code >> ( 32 - leftCount );
                dCode = SecondNode -> code >> ( 32 - leftCount );
                if (aCode == dCode )
                        return 0;
                else
                        if (aCode < dCode)
                                return 2;
                        else return 1;
        }
        else
        {
                if (leftCount == 0)
                        dCode = 1;
                else
                        dCode = ( SecondNode -> code >> ( 31 - leftCount )) | 1 ;
                aCode = FirstNode -> code >> ( 31 - leftCount );
                if ( aCode == dCode )
                        return 3;
                else
                        if (aCode < dCode)
                                return 2;
                        else return 1;

        }

}

